var map = new L.Map('map', {

  layers: [
    new L.TileLayer('tiles/DOLOMITI/{z}/{x}/{y}.png', {
      minZoom: 9,
      maxZoom: 15,
      continuousWorld: true
    }), 

    new L.Marker(new L.LatLng(46.000, 11.000), {
      title: 'Trento'
    }),
    new L.Marker(new L.LatLng(46.08359, 11.11439), {
      title: 'Trento2'
    })

  ],
  center: new L.LatLng(46.4083,11.661),
  zoom: 10,
  continuousWorld: true

});

var url = 'gpx/Cima-Bocche.gpx'; // URL to your GPX file
new L.GPX(url, {async: true}).on('loaded', function(e) {
  map.fitBounds(e.target.getBounds());
}).addTo(map);

var popup = L.popup();

function onMapClick(e) {
    popup
        .setLatLng(e.latlng)
        .setContent("You clicked the map at " + e.latlng.toString())
        .openOn(map);
}

map.on('click', onMapClick);


